"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.warn = exports.info = exports.error = void 0;
exports.init = init;
const application_error_1 = require("./errors/application.error");
const Logger = __importStar(require("./LoggerProxy"));
const instance = {
    report: (error, options) => {
        if (error instanceof Error) {
            let e = error;
            const { executionId } = options ?? {};
            const context = executionId ? ` (execution ${executionId})` : '';
            do {
                const msg = [e.message + context, e.stack ? `\n${e.stack}\n` : ''].join('');
                const meta = e instanceof application_error_1.ApplicationError ? e.extra : undefined;
                Logger.error(msg, meta);
                e = e.cause;
            } while (e);
        }
    },
};
function init(errorReporter) {
    instance.report = errorReporter.report;
}
const wrap = (e) => {
    if (e instanceof Error)
        return e;
    if (typeof e === 'string')
        return new application_error_1.ApplicationError(e);
    return;
};
const error = (e, options) => {
    const toReport = wrap(e);
    if (toReport)
        instance.report(toReport, options);
};
exports.error = error;
const info = (msg, options) => {
    Logger.info(msg);
    instance.report(msg, { ...options, level: 'info' });
};
exports.info = info;
const warn = (warning, options) => (0, exports.error)(warning, { ...options, level: 'warning' });
exports.warn = warn;
//# sourceMappingURL=ErrorReporterProxy.js.map